#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>

#include "applu.h"

pintgr()
{
	double phi1[isiz2][isiz1], phi2[isiz2][isiz1];
	int i, j, k;
	double frc1, frc2, frc3;

	for(j=ji1;j<=ji2;j++) {
		for(i=ii1;i<=ii2;i++) {
			phi1[j][i] = c2*(u[ki1][j][i][4]
				- 0.5*(u[ki1][j][i][1]*u[ki1][j][i][1]
					  +u[ki1][j][i][2]*u[ki1][j][i][2]
					  +u[ki1][j][i][3]*u[ki1][j][i][3])
					 /u[ki1][j][i][0]);
			phi2[j][i] = c2*(u[ki2][j][i][4]
				- 0.5*(u[ki2][j][i][1]*u[ki2][j][i][1]
					  +u[ki2][j][i][2]*u[ki2][j][i][2]
					  +u[ki2][j][i][3]*u[ki2][j][i][3])
					 /u[ki2][j][i][0]);
		}
	}
	frc1 = 0.0;
	for(j=ji1;j<=(ji2-1);j++) {
		for(i=ii1;i<=(ii2-1);i++) {
			frc1 += (phi1[j][i]
					+phi1[j][i+1]
					+phi1[j+1][i]
					+phi1[j+1][i+1]
					+phi2[j][i]
					+phi2[j][i+1]
					+phi2[j+1][i]
					+phi2[j+1][i+1]);
		}
	}
	frc1 = dxi * deta * frc1;

	for(k=ki1;k<=ki2;k++) {
		for(i=ii1;i<=ii2;i++) {
			phi1[k][i] = c2*(u[k][ji1][i][4]
				- 0.5*(u[k][ji1][i][1]*u[k][ji1][i][1]
					  +u[k][ji1][i][2]*u[k][ji1][i][2]
					  +u[k][ji1][i][3]*u[k][ji1][i][3])
					 /u[k][ji1][i][0]);
			phi2[k][i] = c2*(u[k][ji2][i][4]
				- 0.5*(u[k][ji2][i][1]*u[k][ji2][i][1]
					  +u[k][ji2][i][2]*u[k][ji2][i][2]
					  +u[k][ji2][i][3]*u[k][ji2][i][3])
					 /u[k][ji2][i][0]);
		}
	}
	frc2 = 0.0;
	for(k=ki1;k<=(ki2-1);k++) {
		for(i=ii1;i<=(ii2-1);i++) {
			frc2 += (phi1[k][i]
					+phi1[k][i+1]
					+phi1[k+1][i]
					+phi1[k+1][i+1]
					+phi2[k][i]
					+phi2[k][i+1]
					+phi2[k+1][i]
					+phi2[k+1][i+1]);
		}
	}
	frc2 = dxi * dzeta * frc2;

	for(k=ki1;k<=ki2;k++) {
		for(j=ji1;j<=ji2;j++) {
			phi1[k][j] = c2*(u[k][j][ii1][4]
				- 0.5*(u[k][j][ii1][1]*u[k][j][ii1][1]
					  +u[k][j][ii1][2]*u[k][j][ii1][2]
					  +u[k][j][ii1][3]*u[k][j][ii1][3])
					 /u[k][j][ii1][0]);
			phi2[k][j] = c2*(u[k][j][ii2][4]
				- 0.5*(u[k][j][ii2][1]*u[k][j][ii2][1]
					  +u[k][j][ii2][2]*u[k][j][ii2][2]
					  +u[k][j][ii2][3]*u[k][j][ii2][3])
					 /u[k][j][ii2][0]);
		}
	}
	frc3 = 0.0;
	for(k=ki1;k<=(ki2-1);k++) {
		for(j=ji1;j<=(ji2-1);j++) {
			frc3 += (phi1[k][j]
					+phi1[k][j+1]
					+phi1[k+1][j]
					+phi1[k+1][j+1]
					+phi2[k][j]
					+phi2[k][j+1]
					+phi2[k+1][j]
					+phi2[k+1][j+1]);
		}
	}
	frc3 = deta * dzeta * frc3;

	frc = 0.25 * (frc1 + frc2 + frc3);
	fprintf(outp,"surface integral = %e\n", frc);
}

